#ifndef __DNS2_PRIVATE_H__
#define __DNS2_PRIVATE_H__

#include <stdio.h>
#include <stdlib.h>

#include <time.h>

#include "packet.h"
#include "glist.h"
#include "rr.h"
#include "dns2.h"

struct _DNS2 {
	int type;
	int timeout;
	
	/* Lista nameservers a los cuáles mandar la petición */
	GList *nameservers;
	
	/* Se utiliza para las actualizaciones de zona */
	char *zone;
	
	DNSPacket *packet;
	
	/* Para la recepción de datos */
	unsigned char buffer_read[8192];
	int buffer_read_pos;
	
	DNSPacket *packet_response;
	int force_use_tcp;
	
	/* Usado para saber si quiere recursión en las consultas */
	int want_recursion;
	
	DNSRR *auth_signature;
	
	/* Para el envio de red */
	int state;
	int direction;
	int retry_count;
	struct timespec last_time_sent;
	
	GList *current_ns;
};

DNS2 *dns2_new (void);

#endif /* __DNS2_PRIVATE_H__ */

